﻿using HeuristicLab.Algorithms.PushGP.Expressions.Exec;
using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
{
    public class CodeDefineExpression : Expression
    {
        public override bool IsCodeOp { get { return true; } }

        public override void Eval(IInterpreter interpreter)
        {
            // not enough arguments on stack
            if (interpreter.NameStack.Count == 0 ||
                interpreter.CodeStack.Count == 0)
                return;

            var name = interpreter.NameStack.Pop();
            var expression = new ExecPushExpression(interpreter.CodeStack.Top);

            if (interpreter.CustomExpressions.ContainsKey(name))
            {
                interpreter.CustomExpressions[name] = expression;
            }
            else
            {
                interpreter.CustomExpressions.Add(name, expression);
            }

            interpreter.CodeStack.Pop();
        }

        public override string ToString()
        {
            return Symbols.CodeDefine;
        }
    }
}
