﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
{
    public class CodeIfExpression : Expression
    {
        public override bool IsCodeOp { get { return true; } }

        public override void Eval(IInterpreter interpreter)
        {
            // not enough arguments on stack
            if (interpreter.BooleanStack.Count == 0 ||
                interpreter.CodeStack.Count < 2)
                return;

            var condition = interpreter.BooleanStack.Pop();
            var expressionFalse = interpreter.CodeStack.Pop();
            var expressionTrue = interpreter.CodeStack.Pop();

            interpreter.ExecStack.Push(condition
                ? expressionTrue
                : expressionFalse);
        }

        public override string ToString()
        {
            return Symbols.CodeIf;
        }
    }
}
