﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Integer
{
    public class IntegerPushExpression : Expression
    {
        private readonly long value;
        public IntegerPushExpression(long value)
        {
            this.value = value;
        }

        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            interpreter.IntegerStack.Push(this.value);
        }

        public override string ToString()
        {
            return this.value.ToString();
        }
    }
}
