﻿using System;
using HeuristicLab.Algorithms.PushGP.Interpreter;
using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Templates
{
    public class PopExpressionTemplate<T> : ExpressionTemplate
    {
        private readonly Func<IInterpreter, IStack<T>> sourceStackProvider;
        private readonly bool isCodeOp;
        public PopExpressionTemplate(string symbol, Func<IInterpreter, IStack<T>> sourceStackProvider, bool isCodeOp = false) : base(symbol)
        {
            this.sourceStackProvider = sourceStackProvider;
            this.isCodeOp = isCodeOp;
        }

        public override bool IsCodeOp { get { return this.isCodeOp; } }

        public override void Eval(IInterpreter interpreter)
        {
            var sourceStack = this.sourceStackProvider(interpreter);

            // not enough arguments on stack
            if (sourceStack.Count == 0)
                return;

            sourceStack.Pop();
        }
    }
}
